<center><a href="lsparams.c">Actual source code: lsparams.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:30:47+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCSNES_DLL</font></strong>

<a name="line3"> 3: </a> #include <A href="../../../../src/snes/impls/ls/ls.h.html">src/snes/impls/ls/ls.h</A>

<a name="line7">  7: </a><font color="#B22222">/*@</font>
<a name="line8">  8: </a><font color="#B22222">   <A href="../../../../docs/manualpages/SNES/SNESLineSearchSetParams.html#SNESLineSearchSetParams">SNESLineSearchSetParams</A> - Sets the parameters associated with the line search</font>
<a name="line9">  9: </a><font color="#B22222">   routine in the Newton-based method <A href="../../../../docs/manualpages/SNES/SNESLS.html#SNESLS">SNESLS</A>.</font>

<a name="line11"> 11: </a><font color="#B22222">   Collective on <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A></font>

<a name="line13"> 13: </a><font color="#B22222">   Input Parameters:</font>
<a name="line14"> 14: </a><font color="#B22222">+  snes    - The nonlinear context obtained from <A href="../../../../docs/manualpages/SNES/SNESCreate.html#SNESCreate">SNESCreate</A>()</font>
<a name="line15"> 15: </a><font color="#B22222">.  alpha   - The scalar such that .5*f_{n+1} . f_{n+1} &lt;= .5*f_n . f_n - alpha |f_n . J . f_n|</font>
<a name="line16"> 16: </a><font color="#B22222">.  maxstep - The maximum norm of the update vector</font>
<a name="line17"> 17: </a><font color="#B22222">-  steptol - The minimum norm fraction of the original step after scaling</font>

<a name="line19"> 19: </a><font color="#B22222">   Level: intermediate</font>

<a name="line21"> 21: </a><font color="#B22222">   Note:</font>
<a name="line22"> 22: </a><font color="#B22222">   Pass in <A href="../../../../docs/manualpages/Sys/PETSC_DEFAULT.html#PETSC_DEFAULT">PETSC_DEFAULT</A> for any parameter you do not wish to change.</font>

<a name="line24"> 24: </a><font color="#B22222">   We are finding the zero of f() so the one dimensional minimization problem we are</font>
<a name="line25"> 25: </a><font color="#B22222">   solving in the line search is minimize .5*f(x_n + lambda*step_direction) . f(x_n + lambda*step_direction)</font>

<a name="line27"> 27: </a><font color="#B22222">   Contributed by: Mathew Knepley</font>

<a name="line29"> 29: </a><font color="#B22222">.keywords: <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A>, nonlinear, set, line search params</font>

<a name="line31"> 31: </a><font color="#B22222">.seealso: <A href="../../../../docs/manualpages/SNES/SNESLineSearchGetParams.html#SNESLineSearchGetParams">SNESLineSearchGetParams</A>(), <A href="../../../../docs/manualpages/SNES/SNESLineSearchSet.html#SNESLineSearchSet">SNESLineSearchSet</A>()</font>
<a name="line32"> 32: </a><font color="#B22222">@*/</font>
<a name="line33"> 33: </a><strong><font color="#4169E1"><a name="SNESLineSearchSetParams"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../docs/manualpages/SNES/SNESLineSearchSetParams.html#SNESLineSearchSetParams">SNESLineSearchSetParams</A>(<A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> snes,<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> alpha,<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> maxstep,<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> steptol)</font></strong>
<a name="line34"> 34: </a>{
<a name="line35"> 35: </a>  SNES_LS *ls;


<a name="line40"> 40: </a>  ls = (SNES_LS*)snes-&gt;data;
<a name="line41"> 41: </a>  <font color="#4169E1">if</font> (alpha   &gt;= 0.0) ls-&gt;alpha   = alpha;
<a name="line42"> 42: </a>  <font color="#4169E1">if</font> (maxstep &gt;= 0.0) ls-&gt;maxstep = maxstep;
<a name="line43"> 43: </a>  <font color="#4169E1">if</font> (steptol &gt;= 0.0) ls-&gt;steptol = steptol;
<a name="line44"> 44: </a>  <font color="#4169E1">return</font>(0);
<a name="line45"> 45: </a>}

<a name="line49"> 49: </a><font color="#B22222">/*@C</font>
<a name="line50"> 50: </a><font color="#B22222">   <A href="../../../../docs/manualpages/SNES/SNESLineSearchGetParams.html#SNESLineSearchGetParams">SNESLineSearchGetParams</A> - Gets the parameters associated with the line search</font>
<a name="line51"> 51: </a><font color="#B22222">     routine in the Newton-based method <A href="../../../../docs/manualpages/SNES/SNESLS.html#SNESLS">SNESLS</A>.</font>

<a name="line53"> 53: </a><font color="#B22222">   Not collective, but any processor will return the same values</font>

<a name="line55"> 55: </a><font color="#B22222">   Input Parameters:</font>
<a name="line56"> 56: </a><font color="#B22222">+  snes    - The nonlinear context obtained from <A href="../../../../docs/manualpages/SNES/SNESCreate.html#SNESCreate">SNESCreate</A>()</font>
<a name="line57"> 57: </a><font color="#B22222">.  alpha   - The scalar such that .5*f_{n+1} . f_{n+1} &lt;= .5*f_n . f_n - alpha |f_n . J . f_n|</font>
<a name="line58"> 58: </a><font color="#B22222">.  maxstep - The maximum norm of the update vector</font>
<a name="line59"> 59: </a><font color="#B22222">-  steptol - The minimum norm fraction of the original step after scaling</font>

<a name="line61"> 61: </a><font color="#B22222">   Level: intermediate</font>

<a name="line63"> 63: </a><font color="#B22222">   Note:</font>
<a name="line64"> 64: </a><font color="#B22222">    To not get a certain parameter, pass in <A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A></font>

<a name="line66"> 66: </a><font color="#B22222">   We are finding the zero of f() so the one dimensional minimization problem we are</font>
<a name="line67"> 67: </a><font color="#B22222">   solving in the line search is minimize .5*f(x_n + lambda*step_direction) . f(x_n + lambda*step_direction)</font>

<a name="line69"> 69: </a><font color="#B22222">   Contributed by: Mathew Knepley</font>

<a name="line71"> 71: </a><font color="#B22222">.keywords: <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A>, nonlinear, set, line search parameters</font>

<a name="line73"> 73: </a><font color="#B22222">.seealso: <A href="../../../../docs/manualpages/SNES/SNESLineSearchSetParams.html#SNESLineSearchSetParams">SNESLineSearchSetParams</A>(), <A href="../../../../docs/manualpages/SNES/SNESLineSearchSet.html#SNESLineSearchSet">SNESLineSearchSet</A>()</font>
<a name="line74"> 74: </a><font color="#B22222">@*/</font>
<a name="line75"> 75: </a><strong><font color="#4169E1"><a name="SNESLineSearchGetParams"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../docs/manualpages/SNES/SNESLineSearchGetParams.html#SNESLineSearchGetParams">SNESLineSearchGetParams</A>(<A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> snes,<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *alpha,<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *maxstep,<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *steptol)</font></strong>
<a name="line76"> 76: </a>{
<a name="line77"> 77: </a>  SNES_LS *ls;


<a name="line82"> 82: </a>  ls = (SNES_LS*)snes-&gt;data;
<a name="line83"> 83: </a>  <font color="#4169E1">if</font> (alpha) {
<a name="line85"> 85: </a>    *alpha   = ls-&gt;alpha;
<a name="line86"> 86: </a>  }
<a name="line87"> 87: </a>  <font color="#4169E1">if</font> (maxstep) {
<a name="line89"> 89: </a>    *maxstep = ls-&gt;maxstep;
<a name="line90"> 90: </a>  }
<a name="line91"> 91: </a>  <font color="#4169E1">if</font> (steptol) {
<a name="line93"> 93: </a>    *steptol = ls-&gt;steptol;
<a name="line94"> 94: </a>  }
<a name="line95"> 95: </a>  <font color="#4169E1">return</font>(0);
<a name="line96"> 96: </a>}

</pre>
</body>

</html>
